/*
  ணࠬ HILBERT.
  ਢ 졥  浪.
*/

#include <conio.h>
#include <graphics.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

int X_max, Y_max, foregrcolor, backgrcolor, colorsum;
static int Xcur, Ycur;
float x_max, y_max, horfact, vertfact;

void boundaries_uc(void)
{

  int w, h;
  getaspectratio(&w, &h);
  y_max = x_max * (float)Y_max * h/((float)X_max * w);
  horfact = X_max/x_max;
  vertfact = Y_max/y_max;

}

void initgr(void)
{

  int grdriver = DETECT, grmode;

  detectgraph(&grdriver, &grmode);
  initgraph(&grdriver, &grmode, "");

  if ( graphresult() != grOk )
   printf("\n䨪  樠஢!\n");

  foregrcolor = getcolor();
  backgrcolor = getbkcolor();
  colorsum = foregrcolor + backgrcolor;

  X_max = getmaxx();
  Y_max = getmaxy();

  x_max = 10.0;

  boundaries_uc();

}

int IX(float x)
{

  return (int)(x * horfact + 0.5);

}

int IY(float y)
{

  return Y_max - (int)(y * vertfact + 0.5);

}

void move(float x, float y)
{

  Xcur = IX(x);
  Ycur = IY(y);
  moveto(Xcur, Ycur);

}

void draw(float x, float y)
{

  int X0 = Xcur, Y0 = Ycur;
  Xcur = IX(x);
  Ycur = IY(y);
  line(X0, Y0, Xcur, Ycur);
  moveto(Xcur, Ycur);

}

void endgr(void)
{

  getch();
  closegraph();

}

typedef struct { float x, y; } vec;
int recdepth, steps;

void hilbert(vec A, vec B, vec C, vec dAB, vec dAC, int n)
{

  vec D, E, F, G, H, I, J, K, L;

  if ( n > 0 )
   {

	 D.x = (A.x + C.x - dAC.x)/2;
	 D.y = (A.y + C.y - dAC.y)/2;
	 E.x = (A.x + B.x - dAB.x)/2;
	 E.y = (A.y + B.y - dAB.y)/2;
	 F.x = D.x + dAC.x;
	 F.y = D.y + dAC.y;
	 G.x = F.x + E.x - A.x;
	 G.y = F.y + E.y - A.y;
	 H.x = G.x + dAB.x;
	 H.y = G.y + dAB.y;
	 I.x = F.x + B.x - A.x;
	 I.y = F.y + B.y - A.y;
	 J.x = C.x + H.x - F.x;
	 J.y = C.y + H.y - F.y;
	 K.x = I.x - dAC.x;
	 K.y = I.y - dAC.y;
	 L.x = H.x - dAC.x;
	 L.y = H.y - dAC.y;

	 hilbert(A, D, E, dAC, dAB, n - 1);
	 draw(F.x, F.y); //  DF

	 hilbert(F, G, C, dAB, dAC, n - 1);
	 draw(H.x, H.y); //  GH

	 hilbert(H, I, J, dAB, dAC, n - 1);
	 draw(K.x, K.y); //  IK

	 //   ஢ dAB  dAC  ⮫쪮 묨
	 dAB.x = -dAB.x;
	 dAB.y = -dAB.y;
	 dAC.x = -dAC.x;
	 dAC.y = -dAC.y;

	 hilbert(K, B, L, dAC, dAB, n - 1);

   }

}

void square(float xA, float yA, float xB, float yB, float xC, float yC)
{

  vec A, B, C, dAB, dAC;
  A.x = xA;
  A.y = yA;
  B.x = xB;
  B.y = yB;
  C.x = xC;
  C.y = yC;

  dAB.x = (xB - xA)/steps;
  dAB.y = (yB - yA)/steps;
  dAC.x = (xC - xA)/steps;
  dAC.y = (yC - yA)/steps;

  move(xA, yA);
  hilbert(A, B, C, dAB, dAC, recdepth);

}

void main()
{

  clrscr();
  float xCenter, yCenter, h, xP, yP, xQ, yQ, xR, yR;

  printf(" 㡨 ४ᨨ: ");
  scanf("%d", &recdepth);
  steps = (1 << recdepth) - 1; // steps = power(2, recdepth) - 1
    
  initgr();

  xCenter = x_max/2;
  yCenter = y_max/2;
  h = y_max/40;

  xP = xR = xCenter - 3 * h;
  xQ = xCenter + 3 * h;
  yP = yQ = yCenter - 4 * h;
  yR = yCenter + 4 * h;

  square(xQ, yQ, xR, yR, xQ + 8 * h, yQ + 6 * h); // ࠢ 
  square(xR, yR, xP, yP, xR - 8 * h, yR); //  
  square(xP, yP, xQ, yQ, xP, yP - 6 * h); //  

  endgr();

}