{
  ணࠬ HILBERT.
  ਢ 졥  浪.
}

uses crt, graph;

type
 vec = record
  x, y : real
 end;

var
 X_max, Y_max, foregrcolor, backgrcolor, colorsum : integer;
 Xcur, Ycur : integer;
 x_max1, y_max1, horfact, vertfact : real;
 recdepth, steps : integer;
 xCenter, yCenter, h, xP, yP, xQ, yQ, xR, yR : real;

procedure boundaries_uc;
var w, h : word;
begin
  getaspectratio(w, h);
  y_max1 := x_max1 * Y_max * h/(X_max * w);
  horfact := X_max/x_max1;
  vertfact := Y_max/y_max1
end;

procedure initgr;
var grdriver, grmode : integer;
begin
  grdriver := DETECT;

  detectgraph(grdriver, grmode);
  initgraph(grdriver, grmode, '');

  if ( graphresult <> grOk ) then begin
   writeln;
   writeln('䨪  樠஢!');
   halt
  end;

  foregrcolor := getcolor;
  backgrcolor := getbkcolor;
  colorsum := foregrcolor + backgrcolor;

  X_max := getmaxx;
  Y_max := getmaxy;

  x_max1 := 10;

  boundaries_uc

end;

function IX(x : real) : integer;
begin
 IX := trunc(x * horfact + 0.5)
end;

function IY(y : real) : integer;
begin
 IY := Y_max - trunc(y * vertfact + 0.5)
end;

procedure move(x, y : real);
begin
  Xcur := IX(x);
  Ycur := IY(y);
  moveto(Xcur, Ycur)

end;

procedure draw(x, y : real);
var X0, Y0 : integer;
begin
  X0 := Xcur;
  Y0 := Ycur;
  Xcur := IX(x);
  Ycur := IY(y);
  line(X0, Y0, Xcur, Ycur);
  moveto(Xcur, Ycur)
end;

procedure endgr;
begin
  readkey;
  closegraph
end;

procedure hilbert(A, B, C, dAB, dAC : vec; n : integer);
var D, E, F, G, H, I, J, K, L : vec;
begin
  if ( n > 0 ) then begin
   D.x := (A.x + C.x - dAC.x)/2;
   D.y := (A.y + C.y - dAC.y)/2;
   E.x := (A.x + B.x - dAB.x)/2;
   E.y := (A.y + B.y - dAB.y)/2;
   F.x := D.x + dAC.x;
   F.y := D.y + dAC.y;
   G.x := F.x + E.x - A.x;
   G.y := F.y + E.y - A.y;
   H.x := G.x + dAB.x;
   H.y := G.y + dAB.y;
   I.x := F.x + B.x - A.x;
   I.y := F.y + B.y - A.y;
   J.x := C.x + H.x - F.x;
   J.y := C.y + H.y - F.y;
   K.x := I.x - dAC.x;
   K.y := I.y - dAC.y;
   L.x := H.x - dAC.x;
   L.y := H.y - dAC.y;

   hilbert(A, D, E, dAC, dAB, n - 1);
   draw(F.x, F.y); {  DF }

   hilbert(F, G, C, dAB, dAC, n - 1);
   draw(H.x, H.y); {  GH }

   hilbert(H, I, J, dAB, dAC, n - 1);
   draw(K.x, K.y); {  IK }

   {   ஢ dAB  dAC  ⮫쪮 묨 }
   dAB.x := -dAB.x;
   dAB.y := -dAB.y;
   dAC.x := -dAC.x;
   dAC.y := -dAC.y;

   hilbert(K, B, L, dAC, dAB, n - 1)
  end
end;

procedure square(xA, yA, xB, yB, xC, yC : real);
var A, B, C, dAB, dAC : vec;
begin
  A.x := xA;
  A.y := yA;
  B.x := xB;
  B.y := yB;
  C.x := xC;
  C.y := yC;

  dAB.x := (xB - xA)/steps;
  dAB.y := (yB - yA)/steps;
  dAC.x := (xC - xA)/steps;
  dAC.y := (yC - yA)/steps;

  move(xA, yA);
  hilbert(A, B, C, dAB, dAC, recdepth)
end;

begin
 clrscr;
 write(' 㡨 ४ᨨ: ');
 readln(recdepth);
 steps := (1 shl recdepth) - 1; { steps := 2^recdepth) - 1 }

 initgr;

 xCenter := x_max1/2;
 yCenter := y_max1/2;
 h := y_max1/40;

 xR := xCenter - 3 * h;
 xP := xR;
 xQ := xCenter + 3 * h;
 yQ := yCenter - 4 * h;
 yP := yQ;
 yR := yCenter + 4 * h;

 square(xQ, yQ, xR, yR, xQ + 8 * h, yQ + 6 * h); { ࠢ  }
 square(xR, yR, xP, yP, xR - 8 * h, yR); {   }
 square(xP, yP, xQ, yQ, xP, yP - 6 * h); {   }

 endgr

end.